Subject: Re: bug#33740: [PATCH] Customizable flymake mode-line indicator

From: João Távora <[email-masked]>
Date: Wed, 30 Dec 2020 09:28:22 +0000

On Wed, Dec 30, 2020 at 3:22 AM Lars Ingebrigtsen <[email-masked]> wrote:
>
> João Távora <[email-masked]> writes:
>
> > How is it more feasible to ask her to write such customizations
> > inside a string than asking her to write the same customizations
> > in a symbolic expression?
>
> Format spec strings is the common idiom for customising display stuff in
> Emacs.

Not all of this "stuff" obviously, only the fraction of it that is trivial.
Case in point, the very commonly customized mode-line.
I appreciate the effort to try to move this along, but if you'd
be more aware of Flymake's mode-line mechanics, you'd
see the format-spec function is underpowered currently

I mean, it _could_ become more powerful. See CL:FORMAT for
example (some love it, some hate it, I respect and use it on
occasion).  It could do the job easily, because it has conditional
formatting:

http://www.lispworks.com/documentation/HyperSpec/Body/22_cgb.htm

So, unless format spec grows something similar, it simply isn't the
tool for the job. What growth? See the end of:

https://debbugs.gnu.org/cgi/bugreport.cgi?bug=33740#71

in this thread for a possible start.

> > I don't understand your "don't care" comment.  You don't care
> > for enhancing format-spec to allow for conditional formattings.
>
> Whether Flymake offers a way to customise the lighter (or not) is up to
> you.

I've started work on a `flymake-mode-line`  customizable var, where
users can add and removed pre-baked pieces to control the main
indicator, counters, brackets, etc.  If you're interested in enhancing
format-spec, let me know, else I'll continue this approach.

João